using System;
using System.ComponentModel;

namespace Dapfor.Net.Grid.Tutorial.BusinessData.Currencies
{
    /// <summary>
    /// Read-write property of the CurrencyRate class
    /// </summary>
    internal class CurrencyRatePropertyDescriptor : PropertyDescriptor
    {
        public CurrencyRatePropertyDescriptor(string name, Attribute[] attrs)
            : base(name, attrs)
        {
        }

        public override Type ComponentType
        {
            get { return typeof (CurrencyRate); }
        }

        public override bool IsReadOnly
        {
            get { return false; }
        }

        public override Type PropertyType
        {
            get { return typeof (double); }
        }

        public override bool CanResetValue(object component)
        {
            return false;
        }

        public override object GetValue(object component)
        {
            CurrencyRate rate = (CurrencyRate) component;
            return rate[base.Name].Rate;
        }

        public override void ResetValue(object component)
        {
        }

        public override void SetValue(object component, object value)
        {
            CurrencyRate rate = (CurrencyRate) component;
            rate[base.Name].Rate = (double) value;
        }

        public override bool ShouldSerializeValue(object component)
        {
            return false;
        }
    }
}