using System;
using System.IO;
using System.Windows.Forms;

namespace Dapfor.Net.Grid.Tutorial.Presentation
{
    public partial class DocumentationViewer : UserControl
    {
        readonly string _helpPath = Path.Combine(Path.GetTempPath(), "Dapfor.Net.Tutorial");

        public DocumentationViewer()
        {
            InitializeComponent();

            //Prepare images to display them in webbrowser
            try
            {
                //Ensure directory
                if (!Directory.Exists(_helpPath))
                {
                    Directory.CreateDirectory(_helpPath);
                }

                string basePath = typeof(Program).Namespace + ".Documentation.";

                //Copy images                
                foreach (string resource in typeof(Program).Assembly.GetManifestResourceNames())
                {
                    if (resource.Contains(basePath))
                    {
                        string fileName = resource.Replace(basePath, "");

                        using (FileStream fs = new FileStream(Path.Combine(_helpPath, fileName), FileMode.OpenOrCreate))
                        using (BinaryWriter bw = new BinaryWriter(fs))
                        using (Stream stream = typeof(Program).Assembly.GetManifestResourceStream(resource))
                        {
                            if (stream != null)
                            {
                                byte[] bytes = new byte[stream.Length];
                                stream.Read(bytes, 0, bytes.Length);
                                bw.Write(bytes);
                                bw.Flush();
                            }
                        }
                    }
                }

                webBrowser1.Url = new Uri(Path.Combine(_helpPath, "tutorial_0_introduction.html"));
            }
            catch{}
        }
    }
}